Subject: SLP questions

From: Timothy S Zurcher <[email-masked]>
Date: Mon, 16 Apr 2001 09:53:34 -0700

I've been looking over the OpenSLP functionality (and SLP in general),
and have a few high level questions wrt using OpenSLP (and SLP in general).
Since most of the questions are really related to SLP in general,
I'm posting to both groups (srvloc and openslp).

I'd appreciate any feedback on the following:

  1) It looks like the functionality spec'd by RFC2614 is mainly 
     suited to UAs.  I see that there are API calls for SAs to use
     as well (like SLPReg), but it does not look like there are sufficient
     calls to support all of the things that an SA must support.
     Is this correct?  

     It looks as though the API offers calls to initiate actions, but don't
     SAs also have to respond to requests initiated by UAs?  
     Mainly, I don't see how the API offers up the functionality for an SA
     to reply to UA requests (like SrvRqst).
     Am I just missing something?

  2) Here's what I want to do:

       - Implement an embedded SA.
       - The embedded SA will register a standard service type.

     From looking at the OpenSLP stuff, looks like the slpd is a good
     starting point for an embedded SA.  Are there certain configuration
     parameters that I need to set so that the slpd acts as an SA only,
     and does not look like (or act as) a DA on the network?

  3) For an embedded SA, I suspect that having an slp.reg (Serialized
     Registration File) file is not an issue, since I'll be directly 
     supporting a standard service type.
     Does that make sense?

  4) With regard to the slp.conf file (Configuration File Format), I'd treat
     it differently.  Instead of having the slp.conf file exist as the text
     file living on a disk system, it'd be parameters stored in non-volatile
     RAM that are configurable via a gui (like via a browser).
     Is that an issue, and is it a reasonable approach?

     Also, do all of the parameters in slp.conf need to be user configurable? 
     Can't I default many of them, and chose the parameters that I want
     to be user configurable?  Or, do all of the Configuration File
     parameters need to be user settable?

Thanks,
Tim Zurcher

---

From: James Kempf <[email-masked]>
Date: Tue, 17 Apr 2001 08:51:30 -0700 (PDT)

>
>  I think you helped answer below.  It's the "under the covers by the 
>  library" that got me confused.  Indeed, it was "responding to the UA
>  requests" that I did not see covered in the API.
>
>  I'm guessing that the API library implementation assumes that an 
>  "SA Server" is running, and that the API database is tied into the 
>  "SA Server" database.  Therefore once the SLPReg() has been done to 
>  register a service, the "SA Server" can handle the replies.  
>  Is this what you're saying?
>

Yes, in essence. If you are running a single threaded, embedded
SA, maybe you don't need the SA server. But there needs to be
a process listening on port 427 for UDP and, if you choose to
support the full SLP spec, TCP as well. Typically, in a standard
OS platform implementation, this will be an SA server.

		jak